Attribute VB_Name = "modScanSetup"
Option Explicit
Public Sub SetScanIntervalWithinNearestRange()
    CalculateScanChansAll

    Dim iRet As Integer
    Dim minTime As Double
    Dim maxTime As Double
    
    Dim scanInterval_SAVE As Double
    scanInterval_SAVE = M_201.scanInterval
    
    Dim average_SAVE As Long
    average_SAVE = M_201.average
    
    If average_SAVE < 1 Then
        M_201.average = 1
        average_SAVE = 1
    End If
    
    iRet = CheckScanTime(maxTime, minTime)
    
    'Dim iLo As Integer: Dim iMid As Integer: Dim iHi As Integer: Dim dblRateTest
    Dim iLo, iMid, iHi As Integer: Dim dblRateTest
    iLo = M_201.modeRegLo
    iMid = M_201.modeRegMid
    iHi = M_201.modeRegHi
    dblRateTest = M_201.rate
    
    
'    If iRet = 2 Then       --- if this is 2 then average has been reduced by a power of 2
'    ElseIf iRet = 1 Then   --- successful return, no change of average
'    ElseIf iRet = 0 Then   --- scan interval still out of limits even after reducing average by power of 2
    
    If iRet = 2 Then            'average has been reduced by a power of 2 (unlikely first time through
        If (scanInterval_SAVE < minTime) Then
            scanInterval_SAVE = minTime
        ElseIf (scanInterval_SAVE > maxTime) Then
            scanInterval_SAVE = maxTime
        Else
            scanInterval_SAVE = scanInterval_SAVE * 2#
            M_201.scanInterval = scanInterval_SAVE
        End If
    
        If M_201.average = 0 Then
            M_201.average = 1
        Else
            M_201.average = M_201.average / 2
        End If
        
        iRet = CheckScanTime(maxTime, minTime)
    ElseIf iRet = 1 Then        'successful return, no change of average or interval
        'nothing to do
    ElseIf iRet = 0 Then        'scan interval out of limits and average reduced by power of 2 (is now 0)
        If scanInterval_SAVE < minTime Then
            scanInterval_SAVE = minTime
            If (M_201.average < average_SAVE) Then
                'not sure what to do here
                'M_201.average = M_201.average * 2
            End If
            M_201.scanInterval = scanInterval_SAVE
        ElseIf scanInterval_SAVE > maxTime Then
            scanInterval_SAVE = maxTime
        End If
        M_201.scanInterval = scanInterval_SAVE
        iRet = CheckScanTime(maxTime, minTime)
    End If
    
    '9-2-05
    iLo = M_201.modeRegLo
    iMid = M_201.modeRegMid
    iHi = M_201.modeRegHi
    dblRateTest = M_201.rate
    
    '9-2-05 new start
'    CONFIG_COM = 0
'    CONFIG_REMOTE_AVG = 3
'    CONFIG_SCAN_INTERVAL = 14
    Dim dblRateAndIntSave As Double
    '10-7-05 dblRateAndIntSave = CDbl(frmGraph.txtDataRate.Text)
    
    
    '10-7-05 If dblRateAndIntSave <> M_201.rate Then
    '10-7-05     bConfigChanges(CONFIG_RATE) = 1
    '10-7-05 End If
    
    
    '10-7-05
    Dim strTemp1 As String: Dim strTemp2 As String
    strTemp1 = Format$(dblRateForIni, "###.00")
    strTemp2 = Format$(M_201.rate, "###.00")
    Dim dblT1 As Double: Dim dblT2 As Double
    dblT1 = CDbl(strTemp1): dblT2 = CDbl(strTemp2)
    If dblT1 <> dblT2 Then
        bConfigChanges(CONFIG_RATE) = 1
    End If
    
    '10-7-05 dblRateAndIntSave = CDbl(frmChanSelect.txtUserReqScanInterval.Text)
    '10-7-05 If dblRateAndIntSave <> M_201.scanInterval Then
    '10-7-05     bConfigChanges(CONFIG_SCAN_INTERVAL) = 1
    '10-7-05 End If
    '9-2-05 new end
    
    frmChanSelect.txtValScanIntMin.Text = Format$(minTime, "###.000")
    frmChanSelect.txtValScanIntMax.Text = Format$(maxTime, "###.000")
    frmChanSelect.txtUserReqScanInterval.Text = Format$(M_201.scanInterval, "##.00000")
    '9-2-05 frmChanSelect.txtScanDataRate.Text = Format$(1# / M_201.scanInterval, "####.00")
    dblMinTime = minTime
    dblMaxTime = maxTime
        
    
    '9-2-05  new start
    frmGraph.txtDataRate.Text = Format$(M_201.rate, "###.00")
    frmChanSelect.txtScanDataRate = Format$(M_201.rate, "###.00")
    '9-2-05 new end
    
    '10-7-05b
    '10-15-07 dblRateForIni = M_201.rate
    
    fNewSignonNeeded = True
    
    
End Sub
Public Sub btnGetScanRateMax_Click_DoIt()
    CalculateScanChansAll

    Dim iRet As Integer
    Dim minTime As Double
    Dim maxTime As Double
    
    Dim scanInterval_SAVE As Double
    scanInterval_SAVE = M_201.scanInterval
    
    M_201.scanInterval = 0.001
    
    Dim average_SAVE As Long
    average_SAVE = M_201.average
    If average_SAVE < 1 Then
        M_201.average = 1
        average_SAVE = 1
    End If
    
    'tim check maxtime as used below!
    iRet = CheckScanTime(maxTime, minTime)
    
'    If iRet = 2 Then       --- if this is 2 then average has been reduced by a power of 2
'    ElseIf iRet = 1 Then   --- successful return, no change of average
'    ElseIf iRet = 0 Then   --- scan interval still out of limits even after reducing average by power of 2
    
    
    If iRet = 2 Then            'average has been reduced by a power of 2 (unlikely first time through
        'MsgBox vbCrLf & "got 2 - first time"
        frmChanSelect.txtValScanIntMin.Text = Format$(minTime, "###.000")
        frmChanSelect.txtValScanIntMax.Text = Format$(maxTime, "###.000")
        
        dblUserReqScanInterval = minTime: dblUserReqScanInterval_TEMP = minTime
        dblMinTime = minTime: dblMaxTime = maxTime
        
        frmChanSelect.txtUserReqScanInterval.Text = Format$(minTime, "###.00000")
        
        If (scanInterval_SAVE >= minTime) And (scanInterval_SAVE <= maxTime) Then
            M_201.scanInterval = scanInterval_SAVE
        Else
            If (scanInterval_SAVE < minTime) Then
                M_201.scanInterval = minTime
            ElseIf (scanInterval_SAVE > maxTime) Then
                M_201.scanInterval = maxTime
            End If
        End If
        
    ElseIf iRet = 1 Then        'successful return, no change of average or interval
        'MsgBox vbCrLf & "got 1 - first time"
        frmChanSelect.txtValScanIntMin.Text = Format$(minTime, "###.000")
        frmChanSelect.txtValScanIntMax.Text = Format$(maxTime, "###.000")
        
        dblUserReqScanInterval = minTime: dblUserReqScanInterval_TEMP = minTime
        dblMinTime = minTime: dblMaxTime = maxTime
        
        If (scanInterval_SAVE >= minTime) And (scanInterval_SAVE <= maxTime) Then
            M_201.scanInterval = scanInterval_SAVE
        Else
            If (scanInterval_SAVE < minTime) Then
                M_201.scanInterval = minTime
            ElseIf (scanInterval_SAVE > maxTime) Then
                M_201.scanInterval = maxTime
            End If
        End If
        
        frmChanSelect.txtUserReqScanInterval.Text = Format$(minTime, "##.00000")
    ElseIf iRet = 0 Then        'scan interval out of limits and average reduced by power of 2 (is now 0)
        'MsgBox vbCrLf & "got 0 - first time" & vbCrLf & vbCrLf & "trying with new minuimum interval and averaging" & vbCrLf
        
        '3-30-04 If average_SAVE > 1 Then
        If average_SAVE <> M_201.average Then
            minTime = minTime * average_SAVE: M_201.average = average_SAVE
        End If
        
        If (scanInterval_SAVE >= minTime) And (scanInterval_SAVE <= maxTime) Then
            M_201.scanInterval = minTime
        Else
            If (scanInterval_SAVE < minTime) Then
                M_201.scanInterval = minTime
            ElseIf (scanInterval_SAVE > maxTime) Then
                M_201.scanInterval = maxTime
            End If
        End If
       
        iRet = CheckScanTime(maxTime, minTime)
        'MsgBox vbCrLf & "After trying with new average" & vbCrLf & vbCrLf & "minTime: " & minTime & ",  maxTime: " & maxTime & vbCrLf
        If iRet = 2 Then    'average has been reduced by a power of 2 (this shouldn't happen at this point
            MsgBox "got 2"
        ElseIf iRet = 1 Then    'successful return, no change of average
            '3-30-04 If average_SAVE > 1 Then
            If average_SAVE <> M_201.average Then
                minTime = minTime * average_SAVE
            End If
            
            frmChanSelect.txtValScanIntMin.Text = Format$(minTime, "###.000")
            frmChanSelect.txtValScanIntMax.Text = Format$(maxTime, "###.000")
            
            dblUserReqScanInterval = minTime: dblUserReqScanInterval_TEMP = minTime
            dblMinTime = minTime: dblMaxTime = maxTime
            
            frmChanSelect.txtUserReqScanInterval.Text = Format$(minTime, "##.00000")
'11-6-03            M_201.average = average_SAVE
'11-6-03            comboAvg.Text = average_SAVE
            
        ElseIf iRet = 0 Then 'scan interval still out of limits even after reducing average by power of 2
            MsgBox "got 0"
        End If
    End If
    
    fNewSignonNeeded = True
    
    '10-17-07
    bConfigChanges(CONFIG_SCAN_INTERVAL) = 1
    
End Sub

Public Sub CalculateScanChansAll()
    '4-6-04
    If M_201.tScan = 0 Then
        M_201.numChannels = 1
        Exit Sub
    End If

    Dim bChanCnt As Byte: bChanCnt = 0
    Dim bCurSubChanCnt As Byte: bCurSubChanCnt = 0
    
    Dim bIndex As Byte
    Dim bAny0ChanSelected As Byte: bAny0ChanSelected = 0
    Dim bAny1ChanSelected As Byte: bAny1ChanSelected = 0
    Dim bAny2ChanSelected As Byte: bAny2ChanSelected = 0
    Dim bAny3ChanSelected As Byte: bAny3ChanSelected = 0
    Dim bAny4ChanSelected As Byte: bAny4ChanSelected = 0
    Dim bAny5ChanSelected As Byte: bAny5ChanSelected = 0
    
    Dim bChan0Low As Integer: bChan0Low = 0
    Dim bChan1Low As Integer: bChan1Low = 0
    Dim bChan2Low As Integer: bChan2Low = 0
    Dim bChan3Low As Integer: bChan3Low = 0
    Dim bChan4Low As Integer: bChan4Low = 0
    Dim bChan5Low As Integer: bChan5Low = 0
    
    Dim bChan0Hi As Integer: bChan0Hi = 0
    Dim bChan1Hi As Integer: bChan1Hi = 0
    Dim bChan2Hi As Integer: bChan2Hi = 0
    Dim bChan3Hi As Integer: bChan3Hi = 0
    Dim bChan4Hi As Integer: bChan4Hi = 0
    Dim bChan5Hi As Integer: bChan5Hi = 0
    
    Dim bChan0GotLow As Integer: bChan0GotLow = 0
    Dim bChan1GotLow As Integer: bChan1GotLow = 0
    Dim bChan2GotLow As Integer: bChan2GotLow = 0
    Dim bChan3GotLow As Integer: bChan3GotLow = 0
    Dim bChan4GotLow As Integer: bChan4GotLow = 0
    Dim bChan5GotLow As Integer: bChan5GotLow = 0
    
    
    For bIndex = 0 To 5
        M_201.chan(bIndex) = 16
    Next bIndex
    
    
    For bIndex = 0 To 15
        If frmChanSelect.chkChan0Subs(bIndex).Value = vbChecked Then
            If bChan0GotLow = 0 Then
                M_201.chan(0) = (bIndex * 16) + bIndex
                bChan0GotLow = 1
            Else
                M_201.chan(0) = (M_201.chan(0) And &HF0) + bIndex
            End If
            bChanCnt = bChanCnt + 1: bAny0ChanSelected = 1: frmGraph.txtSub0Volts(bIndex).Text = " waiting": frmGraph.txtSub0Volts(bIndex).Enabled = True
        Else
            frmGraph.txtSub0Volts(bIndex).Text = "     ---": frmGraph.txtSub0Volts(bIndex).Enabled = False
        End If
    Next
    For bIndex = 0 To 15
        If frmChanSelect.chkChan1Subs(bIndex).Value = vbChecked Then
            If bChan1GotLow = 0 Then
                M_201.chan(1) = (bIndex * 16) + bIndex
                bChan1GotLow = 1
            Else
                M_201.chan(1) = (M_201.chan(1) And &HF0) + bIndex
            End If
            bChanCnt = bChanCnt + 1: bAny1ChanSelected = 1: frmGraph.txtSub1Volts(bIndex).Text = " waiting": frmGraph.txtSub1Volts(bIndex).Enabled = True
        Else
            frmGraph.txtSub1Volts(bIndex).Text = "     ---": frmGraph.txtSub1Volts(bIndex).Enabled = False
        End If
    Next
    For bIndex = 0 To 15
        If frmChanSelect.chkChan2Subs(bIndex).Value = vbChecked Then
            If bChan2GotLow = 0 Then
                M_201.chan(2) = (bIndex * 16) + bIndex
                bChan2GotLow = 1
            Else
                M_201.chan(2) = (M_201.chan(2) And &HF0) + bIndex
            End If
            bChanCnt = bChanCnt + 1: bAny2ChanSelected = 1: frmGraph.txtSub2Volts(bIndex).Text = " waiting": frmGraph.txtSub2Volts(bIndex).Enabled = True
        Else
            frmGraph.txtSub2Volts(bIndex).Text = "     ---": frmGraph.txtSub2Volts(bIndex).Enabled = False
        End If
    Next
    For bIndex = 0 To 15
        If frmChanSelect.chkChan3Subs(bIndex).Value = vbChecked Then
            If bChan3GotLow = 0 Then
                M_201.chan(3) = (bIndex * 16) + bIndex
                bChan3GotLow = 1
            Else
                M_201.chan(3) = (M_201.chan(3) And &HF0) + bIndex
            End If
            bChanCnt = bChanCnt + 1: bAny3ChanSelected = 1: frmGraph.txtSub3Volts(bIndex).Text = " waiting": frmGraph.txtSub3Volts(bIndex).Enabled = True
        Else
            frmGraph.txtSub3Volts(bIndex).Text = "     ---": frmGraph.txtSub3Volts(bIndex).Enabled = False
        End If
    Next
    For bIndex = 0 To 15
        If frmChanSelect.chkChan4Subs(bIndex).Value = vbChecked Then
            If bChan4GotLow = 0 Then
                M_201.chan(4) = (bIndex * 16) + bIndex
                bChan4GotLow = 1
            Else
                M_201.chan(4) = (M_201.chan(4) And &HF0) + bIndex
            End If
            bChanCnt = bChanCnt + 1: bAny4ChanSelected = 1: frmGraph.txtSub4Volts(bIndex).Text = " waiting": frmGraph.txtSub4Volts(bIndex).Enabled = True
        Else
            frmGraph.txtSub4Volts(bIndex).Text = "     ---": frmGraph.txtSub4Volts(bIndex).Enabled = False
        End If
    Next
    For bIndex = 0 To 15
        If frmChanSelect.chkChan5Subs(bIndex).Value = vbChecked Then
            If bChan5GotLow = 0 Then
                M_201.chan(5) = (bIndex * 16) + bIndex
                bChan5GotLow = 1
            Else
                M_201.chan(5) = (M_201.chan(5) And &HF0) + bIndex
            End If
            bChanCnt = bChanCnt + 1: bAny5ChanSelected = 1: frmGraph.txtSub5Volts(bIndex).Text = " waiting": frmGraph.txtSub5Volts(bIndex).Enabled = True
        Else
            frmGraph.txtSub5Volts(bIndex).Text = "     ---": frmGraph.txtSub5Volts(bIndex).Enabled = False
        End If
    Next
    
    '4-12-04 fixed a problem associated with checking only one sub channel of any channel
    For bIndex = 0 To 5
        If M_201.chan(bIndex) <> 16 Then
            If ((M_201.chan(bIndex) And &HF0) \ 16) > (M_201.chan(bIndex) And &HF) Then
                M_201.chan(bIndex) = M_201.chan(bIndex) + ((M_201.chan(bIndex) And &HF0) \ 16)
            End If
        End If
    Next bIndex
    
    M_201.numChannels = bChanCnt
    
End Sub

