Attribute VB_Name = "modVB6_m201"
' Lawson Labs, Inc.
' 3239 Phoenixville Pike
' Malvern, PA  19355
' 800 321-5355 or 406 257-5355
' World Wide Web - www.lawsonlabs.com
' filename: VB6_M201
' requires NT_M201.DLL and Win95/98/NT
' Last update 2-25-14


'10-3-14
' lots of changes involving the channel offsets.

'2-25-14
' added call to CheckIniExist_CHoffsets in the form-load code since if the offset and main ini
'  file don't exist and are created at the time of trying to access them, they can't be read until
'  the function that creates them returns. So the only way to get around that is to create them
'  both plenty early as in the form load code
' also added a box to inform the user that they need to run as administrator the first time if the
'  file creation fails. I create the .ini files if needed, when the form loads, wait for one second,
'  and then during the init process I check to see if the .ini files are in place and if not let the
'  user know with a message box that they need to be logged in as administrator the first run

'2-24-14
'fixed creation of M201_grf.ini and CHOffset.ini in windows folder if not already
' there such as in the first time the application is run.

'1-20-14
'Added Public Function copyCHoffsetsToWinFolder() to copy CHoffset.ini to windows folder if not already
' there such as would be the case the first time the app is run.
'Added the following after place where user may answer NO to updating
' CHoffset.ini file. Prior to this it would remain disabled because it was only
' reenabled if the user selected YES.
'frmGraphTextVolts.btnRecordOffsetVoltages.Enabled = True '1-20-14


Option Explicit


Public Const MAX_PATH = 260 '1-20-14 for windows path to copy CHoffset.ini to windows folder if not already there
 


'9-27-13b NOTE NOTE NOTE: Changed all instances of frmGraph.Width to (frmGraph.Width - iMargin)

'9-27-13c
Public dblCalOffsetVal_ForLogFile As Double
Public dblCalFullScaleVal_ForLogFile As Double

'9-27-13b
Public iMargin As Integer


'9-25-13
Public fSkipPlotForAutoScaleUpdate As Boolean

'9-25-13
Public fGotClear As Boolean

'9-24-13 changes to stop zeroing offset array and offset value. As of now, I record
' the current offsets and use those

'9-24-13
Public fResetLocalOffsets As Boolean

'1-14-10
'customized for customer


'10-15-07
Public dblRateRequested As Double

'10-7-05
Public dblRateForIni As Double

Public dblPixsPerVolt_save As Double


Public dlbMouseX_GLOBAL As Double
Public dlbMouseY_GLOBAL As Double

Public dblMouseY As Double
Public dblMouseY_PosFull As Double
Public dblMouseY_NegFull As Double
Public dblMouseY_Full As Double
Public dblMouseY_Center As Double

Public fExpNamePending As Boolean
Public dblScanCntTemp As Double

Public strExperimentName As String
Public strExperimentName_save As String
Public strScanLogfileComment As String

Public iSingleChan_SAVE As Integer
Public bScanType_SAVE As Byte

Public dblVoltageAvgArray_0(32, 16) As Double
Public dblVoltageAvgArray_1(32, 16) As Double
Public dblVoltageAvgArray_2(32, 16) As Double
Public dblVoltageAvgArray_3(32, 16) As Double
Public dblVoltageAvgArray_4(32, 16) As Double
Public dblVoltageAvgArray_5(32, 16) As Double
Public dblVoltageAvgArray_offset(32) As Double
Public dblVoltageAvgArray_fullScale(32) As Double

Public bVoltageAvgArrayIndex As Byte
Public fVoltageAvgArraysNeedsInit As Boolean
Public fVoltageAvgArraysNeedsInit_Pending As Boolean
Public fGraphicScreenClearPending As Boolean

Public fFragmentedGraphChanSelects As Boolean
Public bFragmentedGraphChanSelectList(16) As Byte

Public fAvgChangedWhileScanning As Boolean
Public bLocalAvg As Byte
Public bIntervalBoost As Byte
Public bAllChanArray(5, 16) As Byte

Public dblScanNum As Double
Public bAutoScale As Byte
Public lMainFormWidth As Long
Public lMainFormHeight As Long
Public bLogScanVal As Byte
Public dblGain As Double

Public dblMaxFullScale As Double
Public dblMinFullScale As Double
Public dblActualGraphWidth As Double
Public dblActualGraphRightEdge As Double

Public Const CONFIG_COM = 0
Public Const CONFIG_BAUD = 1
Public Const CONFIG_RATE = 2
Public Const CONFIG_REMOTE_AVG = 3
Public Const CONFIG_LOCAL_AVG = 4
Public Const CONFIG_GAIN = 5
Public Const CONFIG_SAVE_LOG = 6
Public Const CONFIG_GRAPH_AUTOSCALE = 7
Public Const CONFIG_GRAPH_SCALE_MAX = 8
Public Const CONFIG_GRAPH_SCALE_MIN = 9
Public Const CONFIG_GRAPH_SEC_PER_SCRN = 10
Public Const CONFIG_MISC_USE_OFFSET_VOLTS = 11
Public Const CONFIG_tSCAN = 12
Public Const CONFIG_SCAN_CHANS = 13
Public Const CONFIG_SCAN_INTERVAL = 14
Public Const CONFIG_ARRAY_SIZE = 14
Public bConfigChanges(CONFIG_ARRAY_SIZE + 1) As Byte

Public fRecordOffsetsNow As Boolean
Public fSetOffsetsToZero As Boolean

Public fClearGraphicScreenNow As Boolean
Public fSignedOn As Boolean
Public iLocalAvg As Integer
Public dblScanRate As Double
Public dblUserReqScanInterval As Double
Public dblUserReqScanInterval_TEMP As Double
Public dblMinTime As Double
Public dblMaxTime As Double
Public fNewSignonNeeded As Boolean

Public bGraphFullScalePosIsNeg As Byte
Public bGraphFullScaleNegIsPos As Byte
Public frmGraphLeft As Long
Public frmGraphTop As Long
Public iAverage_TEMP As Long

Public dblOffsetVoltages(6, 16) As Double
Public dblOffsetVoltages_TEMP(6, 16) As Double
Public dPrevVoltages(6, 16) As Double

Public fIsEMFapp As Boolean
Public dblMinMaxSubVolts(16) As Double
Public bUseOffsetVoltages As Byte
Public iTotScanChans As Integer

'tim note, this is temporary until .ini file is in place
'  and M_201.chan can be used instead
Public bScanChn0_save(15) As Byte
Public bScanChn1_save(15) As Byte
Public bScanChn2_save(15) As Byte
Public bScanChn3_save(15) As Byte
Public bScanChn4_save(15) As Byte
Public bScanChn5_save(15) As Byte

Public lngScanChanColors(15) As Long
Public bCurGraphSubChan_Global As Byte
Public bCurMainChan_Global As Byte
Public bScanTimerBusy As Byte

'#######################################################
' START Graphics variables
'#######################################################
Public Const MAX_DEV_CNT = 32
Public Const MAX_DEV_CNT_MINUS_ONE = 31
Public bCurIndexOfSelectedDev As Byte
Public iRawCount As Long

Public dVoltage(6, 16) As Double
Public dVoltageValid(6, 16) As Double

Public bChanCnt As Byte
Public fAnyScanRunning As Boolean

Public fTimer1BUSY As Boolean
Public scanCnt As Double
Public fChanSelectBusy As Boolean


'Public LLastY As Integer
'tim temp Public LLastY(16) As Integer
Public LLastY(16) As Long



Public sVFrame As Integer
Public LDotCol As Long
'tim changed back Public LDotCol(6) As Integer
'Public LYPixTotal As Integer
Public LYPixTotal As Long
'Public LXPixTotal As Integer
Public LXPixTotal As Long
Public sDotColorChange As Integer
Public iY As Long

Public dblX As Double
Public dblYFS As Double
Public dblLastX As Double
Public dblYRange As Double
Public dblYIndex As Double
Public dblXRange As Double
Public dblXIndex As Double
Public dblPixsPerSecond As Double
Public dblPixPerDP As Double
Public dblYIndexPix As Double
Public dblXIndexPix As Double
Public dblPixsPerVolt As Double
Public dblCurScanRate(MAX_DEV_CNT) As Double
Public dblZoomFactor As Double
Public dblPercentFullScale As Double
Public fCenterGraph As Boolean
Public fGraphIsDisplayed As Boolean
Public bCurrentChanForGraph(MAX_DEV_CNT) As Byte

Public dblAutoScaleVoltages(16) As Double

'#######################################################
'END  Graphics variables
'#######################################################


Public fAllowExit As Boolean
Type M201
    comPort As Integer           'Serial port COM 1 through 4
    scanInterval As Double       'Scan Interval in seconds
    numChannels As Integer       'Number of channels for multi-channel scan
    tScan As Integer             '0=single chan, 1=normal scan, 2=cal scan
    chan(0 To 5) As Integer      'channel selection codes for multi-chan scan
    singleChan As Integer        'channel selection code for single-chan scan
    lastDigInp As Integer        'last valid digital input word
    version As Integer           'microcode Version, read from Model 201
    channel As Integer           'Current selected channel 0-7
    subChan As Integer           'Current selected sub-channel 0-15
    rawCount As Long             'unscaled A/D count 0 to 16,777,215
    voltage As Double            'voltage in MV
    digOutWord As Long           'digital output word
    wordCnt As Integer           'A/D word count. 2= 16-bit mode, 3= 24-bit
    biPolar As Integer           'Unipolar/bipolar flag. 0= bi, 1= uni
    errorType As Long            'error code from dll GetOneScan function
    filter As Integer            'filter freq. 2= 400Hz, 1= 40, 0= 4Hz
    gain As Integer              'power of 2 for gain. 1=x1, 2=x2, 4=x4, etc
    rate As Single               'internal data rate for A/D
    modeRegLo As Integer         'low byte of compacted A/D mode
    modeRegMid As Integer        'mid byte of compacted A/D mode
    modeRegHi As Integer         'high byte of compacted A/D mode
    BAUD As Integer              '0= 9600, 1= 4800, 2= 2400 . . . 5 = 300
    sleeping As Integer          'Flag. 1= asleep, 0= awake
    standBy As Integer           'Flag. 1= in standby, 0= operating
    timeBaseCnt As Long          'not used(placeholder only), for Model 202 only
    average As Long              'digital averaging in 201 (powers of 2)
    TXQUEUESIZE As Long          'transmit buffer size (not used).
    RXQUEUESIZE As Long          'recieve buffer size. 16 to 32767
End Type

Public NewScanBuff(300) As Byte  'buffer for passing one scan from DLL
Public cc(6) As Integer          'control code workspace
Public M_201 As M201             'M201 structured data shared with DLL
Public CfgFileSpec As String     'Config file name
Public localAvg As Integer       'Averaging done in host
Public IdComDev As Long          'Handle to Com-port (not for use in this code)
Public retVal As Integer         'return value for DLL functions
Public WaitTime As Double        'filter settling time in seconds
Public Msg As String             'message string
Public fStopScan As Boolean      'flag to stop scanning
Public hNT_m201_dll              'handle to DLL


Public FullScaleOutput As Double
Public CountsPerVolt As Double
Public OutputOffset As Double
Public timeBaseCnt As Double
Public VoltsOut As Double
Public DacCnt() As Double       ' Array to hold counts for desired voltages

Public CntrSelectCmd As Integer
Public CntrWriteCmd As Integer
Public CntrCtrl() As Integer    ' Array to hold counter select codes
Public CntrlInit As Integer
Public CntrRead As Integer
Public NumDACs As Integer
Public CountHi As Integer
Public CountLo As Integer
Public OUTB1 As Integer
Public OUTB2 As Integer
Public DAC As Integer

Public fRetVal As Boolean



Declare Function GetWindowsDirectory Lib "kernel32" Alias _
    "GetWindowsDirectoryA" (ByVal lpBuffer As String, ByVal _
    nSize As Long) As Long



'BOOLEAN SP_SetProcessPriorityBoost(BYTE bProcessPriority)
Declare Function SP_SetProcessPriorityBoost Lib "NT_m201.dll" (ByVal bPriority As Byte) As Byte


'NT_M201.DLL external functions
Declare Function SetPtrs Lib "NT_m201.dll" (ByRef T_M201 As M201, _
            ByRef NewScanBuff As Byte) As Integer

'this group of functions corresponds exactly to commands described in
'the programmmer's reference section of your manual
Declare Function DLL_SendPacket Lib "NT_m201.dll" _
        (ByVal bToken As Integer, ByVal bData As Integer) As Boolean
        
Declare Function RemoteAvg Lib "NT_m201.dll" () As Integer
Declare Function FullScaleCal Lib "NT_m201.dll" () As Integer
Declare Function OffsetCal Lib "NT_m201.dll" () As Integer
Declare Function GetDigIn Lib "NT_m201.dll" () As Integer
Declare Function SetDigOut Lib "NT_m201.dll" (ByVal digOutWord As Long) As Integer
Declare Function GetVer Lib "NT_m201.dll" () As Integer
Declare Function GetConversion Lib "NT_m201.dll" () As Integer
Declare Function SetChanCode Lib "NT_m201.dll" () As Integer
Declare Function StopScanning Lib "NT_m201.dll" () As Integer
Declare Function SendADMode Lib "NT_m201.dll" () As Integer
Declare Function GetCheckSum Lib "NT_m201.dll" () As Integer
Declare Function GotoSleep Lib "NT_m201.dll" () As Integer


'starts type of scan determined by sType
Declare Function StartScanning Lib "NT_m201.dll" () As Integer

'gets number of scans in buffer
Declare Function GetNumScansInBuffer Lib "NT_m201.dll" () As Long

'BOOLEAN DoDebug(BYTE bDebugLevel)
Declare Function DoDebug Lib "NT_m201.dll" (ByVal bDebugLevel As Byte) As Byte


'gets number of bytes in buffer
Declare Function GetNumBytesInBuffer Lib "NT_m201.dll" () As Long

'BOOLEAN GetOneScanWithDigin(BOOLEAN* fGotNewDigin, BOOLEAN fGetDigin);
Declare Function GetOneScanWithDigin Lib "NT_m201.dll" (ByRef fGotNewDigin As Byte, _
            ByVal fGetDigin As Byte) As Byte

'establish communications with Model 201 and send all set-up information
Declare Function SignOn Lib "NT_m201.dll" () As Integer

'don't use in this application
Declare Function CloseDevice Lib "NT_m201.dll" () As Integer

'select chan 7, wait, & do offset cal. Select chan 6, wait & do full scale cal.
Declare Function SysCal Lib "NT_m201.dll" () As Integer

'convert rawcount to volts, normally handled in DLL
Declare Function Counts2Volts Lib "NT_m201.dll" () As Double

'fetch one scan, wait scantime first, if one isn't ready
Declare Function GetOneScan Lib "NT_m201.dll" () As Integer

'verify scan timing
Declare Function CheckScanTime Lib "NT_m201.dll" (ByRef maxTime As Double, _
            ByRef minTime As Double) As Integer
            
'gets handle to COM-port used by DLL
Declare Sub GetComHandle Lib "NT_m201.dll" (ByRef IdComDev As Long)

'fetch one conversion, waits COM-timeout determined in DLL, if one isn't ready
Declare Sub Gconv Lib "NT_m201.dll" ()

'remove "size" bytes from serial input buffer(normally used for end-of-scan _
            framing token only)
Declare Sub RemFromBuffer Lib "NT_m201.dll" (ByVal size As Long)

'set pre-filter
Declare Sub SetFilter Lib "NT_m201.dll" (ByVal filter As Integer)

'wait filter delay
Declare Sub FilterDelay Lib "NT_m201.dll" (ByVal filter As Integer)

'Model 202 only
Declare Sub WriteCntr Lib "NT_m201.dll" (ByVal cntPort As Integer, _
            ByVal cntrCount As Long)
            
'Windows API external functions
Declare Function MessageBox Lib "user32" Alias "MessageBoxA" _
    (ByVal hwnd As Long, ByVal lpText As String, ByVal lpCaption As String, _
    ByVal wType As Long) As Long
Declare Function GetModuleHandle Lib "kernel32" Alias "GetModuleHandleA" _
                (ByVal lpModuleName As String) As Long
Declare Function FreeLibrary Lib "kernel32" (ByVal hLibModule As Long) As Long
Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long
Declare Function GetPrivateProfileInt Lib "kernel32" Alias "GetPrivateProfileIntA" (ByVal lpApplicationName As String, ByVal lpKeyName As String, ByVal nDefault As Long, ByVal lpFileName As String) As Long
Public Declare Function WriteProfileString Lib "kernel32" Alias "WriteProfileStringA" (ByVal lpszSection As String, ByVal lpszKeyName As String, ByVal lpszString As String) As Long
Public Declare Function WritePrivateProfileString Lib "kernel32" Alias "WritePrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpString As Any, ByVal lpFileName As String) As Long
Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long) '2-25-14

'End Sub
Public Function InitDACS()
    'All counters are initialized first, each used counter needs it's mode
    ' register set then the count from DacCnt(Dac%) is sent to each the count
    ' represents voltage in all cases except DAC 0 which is the timebase
    ' register. Larger timebases give better resolution. Smaller ones, less
    ' ripple. Change TimebaseCnt and/or NumDacs to suit your needs.
    '******** set these variables as needed ********
    NumDACs = 2             ' Number of DACs in use, 1 to 5.
    FullScaleOutput = 10    ' Set to match your hardware range in volts.
    OutputOffset = 0        ' Set to 5 for +/-5 volt operation
                            '  or 0 for 0 to 5 or 0 to 10 volts.
    timeBaseCnt = 10000     ' Full-scale dac count 2 to 65535.
                            ' One count per mv with timebase of 10000
                            '  and 10 volt range.
                            
    '******** set these variables as needed ********
    CountsPerVolt = timeBaseCnt / FullScaleOutput
                            'number of counts for 1 volt output
    
    CntrSelectCmd = &H9     'command to write selection data to counter
                            'control register. Data is defined below:
    
    '         4-bit control register   bit    3         2        1        0
    '                                     EN 3,4,&5   EN 1&2     A1       A0
    
    CntrlInit = 0           'data to disable counter reads and writes
    
    CntrWriteCmd = &H7      'command to write to counter registers
                            'data is written into selected counter
    
    CntrRead = &HC          'argument for digital input command (&H80)
                            'used to read counters (example not included)
    
    ReDim CntrCtrl(5)       ' Array to hold counter select codes
    ReDim DacCnt(5)         ' Array to hold counts for desired voltages
    DacCnt(0) = timeBaseCnt ' Except this one, which is the timebase
'    For DAC = 1 To NumDACs
'        DacCnt(DAC) = 1
'        frmVB6_M201.ComboDACs.AddItem (DAC)
'    Next DAC                'for initialization
    
                            ' Dacs% can be initialized to any desired voltage
                            ' Here, they are set to the minimum ouput.
    
                            'These are constants for addressing the hardware
    CntrCtrl(0) = &H4       'data to address timebase register
    CntrCtrl(1) = &H5       'data to address Dac 1
    CntrCtrl(2) = &H6       'data to address Dac 2
    CntrCtrl(3) = &H8       'data to address Dac 3
    CntrCtrl(4) = &H9       'data to address Dac 4
    CntrCtrl(5) = &HA       'data to address Dac 5
    
                    ' Counter 0 is used to trigger counters 1 through 5
                    ' MODE 2, 10 MHz clock input
                    ' any count from 2 to 65535 can be used
                    ' higher resolution means slower settling
    
                    ' other counters are voltage outputs
                    ' MODE 1, 10 MHz clock, gated by counter 0
                    ' 1 to TIMEBASECNT counts = 0 to 5 or 10 VDC out
                  
'    frmVB6_M201.ComboDACs.Text = "1"
    For DAC = 0 To NumDACs              'set modes

      If (DAC = 0) Or (DAC = 3) Then    'select mode register
          OUTB1 = CntrSelectCmd         'mode reg needs to be selected only
          OUTB2 = CntrCtrl(DAC) Or &H3  'once per 3-channel counter
          fRetVal = DLL_SendPacket(OUTB1, OUTB2)
      End If
      OUTB1 = CntrWriteCmd
      If DAC = 0 Then
          OUTB2 = &H34                      'write mode 2
      Else
          OUTB2 = &H32 + DAC * 64           'write mode 1
          If DAC > 2 Then OUTB2 = OUTB2 - 192 'adjustment for 2nd counter IC
      End If
      fRetVal = DLL_SendPacket(OUTB1, OUTB2)
    Next DAC                                'done setting modes
    
    For DAC = 0 To NumDACs                  'now set counts
      OUTB1 = CntrSelectCmd
      OUTB2 = CntrCtrl(DAC)                 'select counter register
      fRetVal = DLL_SendPacket(OUTB1, OUTB2)
      CountHi = Int(DacCnt(DAC) / 256)      ' get hi and lo bytes of count
      CountLo = Fix(DacCnt(DAC) - CountHi * 256!)   ' from DacCnt array
      OUTB1 = CntrWriteCmd
      OUTB2 = CountLo                       ' write data low byte
      fRetVal = DLL_SendPacket(OUTB1, OUTB2)
      OUTB2 = CountHi                       ' write data high byte
      fRetVal = DLL_SendPacket(OUTB1, OUTB2)
    Next DAC
    InitDACS = fRetVal
End Function
Public Function SetDACS()
    If DAC < 1 Or DAC > NumDACs Then
        SetDACS = False
        Return
    End If
    DacCnt(DAC) = (VoltsOut + OutputOffset) * CountsPerVolt
    If (DacCnt(DAC) > timeBaseCnt) Then DacCnt(DAC) = timeBaseCnt
    If DacCnt(DAC) < 1 Then DacCnt(DAC) = 1     ' 0 is illegal count
    fRetVal = UpdateCntr
    SetDACS = fRetVal
End Function
Public Function UpdateCntr()
    OUTB1 = CntrSelectCmd
    OUTB2 = CntrCtrl(DAC)                  'select counter register
    fRetVal = DLL_SendPacket(OUTB1, OUTB2)
    UpdateCntr = fRetVal
    If fRetVal = False Then Return
    CountHi = Int(DacCnt(DAC) / 256)        'get hi and lo bytes of count
    CountLo = Fix(DacCnt(DAC) - CountHi * 256!)
    OUTB1 = CntrWriteCmd
    OUTB2 = CountLo                         'data low
    fRetVal = DLL_SendPacket(OUTB1, OUTB2)
    UpdateCntr = fRetVal
    If fRetVal = False Then Return
    OUTB2 = CountHi                         'data high
    fRetVal = DLL_SendPacket(OUTB1, OUTB2)
    UpdateCntr = fRetVal
End Function
Public Sub Wait(WaitTime)
    Dim dblEndTime As Double
    dblEndTime = Timer + WaitTime
    Do While dblEndTime > Timer
        DoEvents
    Loop
End Sub
Public Sub MsgDisplay(Msg)
    Dim retVal As Long
    'MsgBox Msg, vbOK       'this box has no title control
    retVal = MessageBox(0, Msg, "Error ----", 0)
End Sub
Public Sub InitVars_DEFAULT()
    
    'Need to load this from M201_grf.ini
    
    M_201.TXQUEUESIZE = 16
    M_201.RXQUEUESIZE = 32000
    M_201.BAUD = 0
    M_201.comPort = 0
    M_201.scanInterval = 0.00001
    
    M_201.average = 1
    bLocalAvg = 1
    M_201.tScan = 1
    
    M_201.chan(0) = 15
    M_201.chan(1) = 16
    M_201.chan(2) = 16
    M_201.chan(3) = 16
    M_201.chan(4) = 16
    M_201.chan(5) = 16
    
    M_201.singleChan = 64
    M_201.channel = 4
    M_201.subChan = 0
    M_201.wordCnt = 3
    M_201.biPolar = 1
    M_201.filter = 2   '0 = 4 Hz  1 = 40 Hz  2 = 400 Hz
    M_201.gain = 1
    
    '4-2-04
    dblGain = CDbl(M_201.gain)
    
    M_201.rate = 60
    M_201.modeRegLo = 0 '161
    M_201.modeRegMid = 0 '135
    M_201.modeRegHi = 0
    localAvg = 1
    
    M_201.numChannels = 0
    Dim bIndex As Byte
    Dim bLowVal As Byte
    Dim bHiVal As Byte
    
'4-12-04     For bIndex = 0 To 5
'4-12-04         If M_201.chan(bIndex) <> 16 Then
'4-12-04             bLowVal = Int(M_201.chan(bIndex) \ 16)
'4-12-04             bHiVal = (M_201.chan(bIndex) And &HF) + 1
'4-12-04             M_201.numChannels = M_201.numChannels + (bHiVal - bLowVal)
'4-12-04         End If
'4-12-04     Next bIndex
    
    
    
    '4-12-04 START ##################
    '4-12-04 fixed a problem associated with checking only one sub channel of any channel
    For bIndex = 0 To 5
        If M_201.chan(bIndex) <> 16 Then
            If ((M_201.chan(bIndex) And &HF0) \ 16) > (M_201.chan(bIndex) And &HF) Then
                M_201.chan(bIndex) = M_201.chan(bIndex) + ((M_201.chan(bIndex) And &HF0) \ 16)
            End If
        End If
    Next bIndex
    For bIndex = 0 To 5
        If M_201.chan(bIndex) <> 16 Then
            bLowVal = (M_201.chan(bIndex) And &HF0) \ 16
            bHiVal = (M_201.chan(bIndex) And &HF)
            M_201.numChannels = M_201.numChannels + (bHiVal - bLowVal) + 1
        End If
    Next bIndex
    '4-12-04 END ##################
    
   
    
    
    'GRAPHICS #######################
    dblXRange = 60#     ' sec per screen
    dblXIndex = dblXRange
    dblMaxFullScale = 5#
    dblMinFullScale = -5#
    bAutoScale = 1
    bLogScanVal = 1
    
    If bAutoScale = 0 Then
        frmGraph.txtPosFullScale.Text = Format$(dblMaxFullScale, "##.00000")
        frmGraph.txtNegFullScale.Text = Format$(dblMinFullScale, "##.00000")
        'these were changed by us not user
        bConfigChanges(CONFIG_GRAPH_SCALE_MAX) = 0
        bConfigChanges(CONFIG_GRAPH_SCALE_MIN) = 0
    End If
    '################################
    
End Sub
'2-24-14
Public Function copyM201_grfToWinFolder()
    Dim strFolder As String
    Dim lngResult As Long
    On Error GoTo EXIT_ERR
    strFolder = String(MAX_PATH, 0)
    lngResult = GetWindowsDirectory(strFolder, MAX_PATH)
    If lngResult <> 0 Then
        Shell ("CopyIni.bat")
        copyM201_grfToWinFolder = True
    Else
        copyM201_grfToWinFolder = False
    End If
    Exit Function
    
EXIT_ERR:
    MsgBox vbCrLf & "Could not copy M201_grf.ini to Windows folder." _
        & vbCrLf & vbCrLf & "M201_grf.ini should be in current application folder but doesn't seem to be.  " _
        & vbCrLf & vbCrLf & "Please redownload archive from our website" & vbCrLf & vbCrLf
    copyM201_grfToWinFolder = False
End Function
Public Function CheckIniExist_MAIN() As Boolean
    If Dir(Environ$("windir") & "\M201_grf.ini") <> "" Then
      'MsgBox "File exists"
    Else
      'MsgBox "File does not exist"
        Dim copySuccess As Boolean
        If copyM201_grfToWinFolder() = False Then
            MsgBox vbCrLf & "Could not copy M201_grf.ini to Windows folder." _
            & vbCrLf & vbCrLf & "M201_grf.ini should be in current application folder." _
            & vbCrLf & vbCrLf & "Please redownload archive from our website" & vbCrLf & vbCrLf
            CheckIniExist_MAIN = False: Exit Function
        End If
    End If
    CheckIniExist_MAIN = True
    Exit Function

'2-24-14 commented all the following. NOTE that the following does not act the
' same within the IDE as it does from the compiled executable.

'    'do a fake read of the ini without any alternate parameters set to see if it exists
'    Dim lRetVal_LOCAL As Long, strIniString As String: strIniString = String(32, vbNullChar)
'    '2-24-14 On Error GoTo EXIT_ERR
'    On Error GoTo MAKE_INI '2-24-14
'MsgBox "1"
'
'    lRetVal_LOCAL = GetPrivateProfileString("MAIN", "Rate", "60", strIniString, 8, "M201_grf.ini")
'
'    If lRetVal_LOCAL = 0 Then
'MAKE_INI: '2-24-14
'MsgBox "2"
'
'        Error = 0
'        '2-24-14 new code start ##############
'        ' copy ini file that ships with app to windows folder the first time it's run
'        Dim copySuccess As Boolean
'        If copyM201_grfToWinFolder() = False Then
'            MsgBox vbCrLf & "Could not copy M201_grf.ini to Windows folder." _
'                & vbCrLf & vbCrLf & "M201_grf.ini should be in current application folder." _
'                & vbCrLf & vbCrLf & "Please redownload archive from our website" & vbCrLf & vbCrLf
'            CheckIniExist_MAIN = False: GoTo EXIT1
'        End If
'        '2-24-14 new code end ##############
'
'
'
'
'        CheckIniExist_MAIN = False: GoTo EXIT1
'    End If
'    CheckIniExist_MAIN = True: GoTo EXIT1
'
'EXIT_ERR:
'     CheckIniExist_MAIN = False
'
'EXIT1:
'    On Error GoTo 0

End Function
Public Sub ReadIniFileSpecs_MAIN()
    Dim lRetVal_LOCAL As Long
    Dim strIniString As String: strIniString = String(32, vbNullChar)

    If CheckIniExist_MAIN = False Then
'2-25-14
'MsgBox "exiting with error"
    
        GoTo EXIT_ERR
    End If

'2-25-14
'MsgBox "setting error"
    On Error GoTo EXIT_ERR
'2-25-14
'MsgBox "past setting error"
    
    lRetVal_LOCAL = GetPrivateProfileString("MAIN", "TXQUEUESIZE", "16", strIniString, 8, "M201_grf.ini")
    M_201.TXQUEUESIZE = Val(strIniString)
    lRetVal_LOCAL = GetPrivateProfileString("MAIN", "RXQUEUESIZE", "32000", strIniString, 8, "M201_grf.ini")
    M_201.RXQUEUESIZE = Val(strIniString)
    lRetVal_LOCAL = GetPrivateProfileString("MAIN", "BAUD", "0", strIniString, 4, "M201_grf.ini")
    M_201.BAUD = Val(strIniString)
    frmGraph.comboBAUD.Text = M_201.BAUD
    Select Case M_201.BAUD
        Case 0:
            frmGraph.comboBAUD.Text = "9600"
        Case 1:
            frmGraph.comboBAUD.Text = "4800"
        Case 2:
            frmGraph.comboBAUD.Text = "2400"
        Case 3:
            frmGraph.comboBAUD.Text = "1200"
        Case 4:
            frmGraph.comboBAUD.Text = "600"
        Case 5:
            frmGraph.comboBAUD.Text = "300"
    End Select
    
    lRetVal_LOCAL = GetPrivateProfileString("MAIN", "comPort", "0", strIniString, 8, "M201_grf.ini")
    M_201.comPort = Val(strIniString)
    frmGraph.ComboCOM.Text = "1"
'2-25-14
'MsgBox "1"
    
    Select Case M_201.comPort
        Case 0:
            frmGraph.ComboCOM.Text = "1"
        Case 1:
            frmGraph.ComboCOM.Text = "2"
        Case 2:
            frmGraph.ComboCOM.Text = "3"
        Case 3:
            frmGraph.ComboCOM.Text = "4"
        Case 4:
            frmGraph.ComboCOM.Text = "5"
        Case 5:
            frmGraph.ComboCOM.Text = "6"
        Case 6:
            frmGraph.ComboCOM.Text = "7"
        Case 7:
            frmGraph.ComboCOM.Text = "8"
    End Select
    
    'remote averaging (powers of 2)  for example, 1, 2, 4, 8. 16. 32, 64, 128
    lRetVal_LOCAL = GetPrivateProfileString("MAIN", "remoteAvg", "1", strIniString, 4, "M201_grf.ini")
    M_201.average = Val(strIniString)
    
    If (M_201.average <> 1) And (M_201.average <> 2) And (M_201.average <> 4) And (M_201.average <> 8) _
         And (M_201.average <> 16) And (M_201.average <> 32) And (M_201.average <> 64) And (M_201.average <> 128) Then
        M_201.average = 1
    End If
    
    If M_201.average > 128 Then
        M_201.average = 128
    End If
    frmGraph.comboRemoteAvg = M_201.average
    
'2-25-14
'MsgBox "2"
    
    'LOCAL averaging 1 to 32
    lRetVal_LOCAL = GetPrivateProfileString("MAIN", "localAvg", "1", strIniString, 3, "M201_grf.ini")
    bLocalAvg = Val(strIniString)
    If bLocalAvg > 32 Then bLocalAvg = 32
    If bLocalAvg < 1 Then bLocalAvg = 1
    frmGraph.txtLocalAvg = bLocalAvg
    
    lRetVal_LOCAL = GetPrivateProfileString("MISC", "IsEMF", "1", strIniString, 2, "M201_grf.ini")
    Dim bval As Byte: bval = Val(strIniString)
    If bval Then fIsEMFapp = True Else fIsEMFapp = False
    
    lRetVal_LOCAL = GetPrivateProfileString("MAIN", "tScan", "1", strIniString, 8, "M201_grf.ini")
    M_201.tScan = Val(strIniString)
    
    '4-5-04 commented this but need to ask TOM
    'If fIsEMFapp Then
    '    M_201.tScan = 1
    'End If
    
    If (M_201.tScan <> 1) And (M_201.tScan <> 2) And (M_201.tScan <> 0) Then M_201.tScan = 1
    If M_201.tScan = 2 Then
        frmChanSelect.comboChanSelectScanType.Text = "multi-chan cal"
    ElseIf M_201.tScan = 0 Then
        frmChanSelect.comboChanSelectScanType.Text = "single-chan"
    End If
    bScanType_SAVE = M_201.tScan
    
    'new 10-7-14 start ###############
    If fIsEMFapp = True Then
        frmGraph.txtSubLabel(0).Text = "sub 1": frmGraph.txtSubLabel(1).Text = "sub 2": frmGraph.txtSubLabel(2).Text = "sub 3"
        frmGraph.txtSubLabel(3).Text = "sub 4": frmGraph.txtSubLabel(4).Text = "sub 5": frmGraph.txtSubLabel(5).Text = "sub 6"
        frmGraph.txtSubLabel(6).Text = "sub 7": frmGraph.txtSubLabel(7).Text = "sub 8": frmGraph.txtSubLabel(8).Text = "sub 9"
        frmGraph.txtSubLabel(9).Text = "sub 10": frmGraph.txtSubLabel(9).Left = 390
        frmGraph.txtSubLabel(10).Text = "sub 11": frmGraph.txtSubLabel(11).Text = "sub 12"
        frmGraph.txtSubLabel(12).Text = "sub 13": frmGraph.txtSubLabel(13).Text = "sub 14": frmGraph.txtSubLabel(14).Text = "sub 15"
        frmGraph.txtSubLabel(15).Text = "sub 16"
        frmGraph.txtChanLabel(0).Text = "Chan 1": frmGraph.txtChanLabel(1).Text = "Chan 2": frmGraph.txtChanLabel(2).Text = "Chan 3"
        frmGraph.txtChanLabel(3).Text = "Chan 4": frmGraph.txtChanLabel(4).Text = "Chan 5": frmGraph.txtChanLabel(5).Text = "Chan 6"
    End If
    'new 10-7-14 end ###############
    
    Dim dblRate As Double
    lRetVal_LOCAL = GetPrivateProfileString("MAIN", "Rate", "60.09", strIniString, 8, "M201_grf.ini")
    M_201.rate = CDbl(Val(strIniString))
    '9-2-05 frmGraph.txtDataRate = strIniString
    '9-2-05
    '10-17-07 frmGraph.txtDataRate = Format$(strIniString, "###.00")
    frmGraph.txtDataRate.Text = Format$(strIniString, "###.00")
    
'2-25-14
'MsgBox "3"
    
    '10-17-07 format the rate to 2 decimal places
    Dim tempRateString As String
    tempRateString = Format$(M_201.rate, "###.00")
    M_201.rate = CDbl(tempRateString)
    '10-17-07 ====================================
    
    dblRateForIni = M_201.rate      'okay to set this here, because it's coming out of the .ini file
    dblRateRequested = M_201.rate   '10-15-07
    
    '1-18-10 the following needs help. We cannot set the interval in the ini file, and we need to make sure
    ' that it is set, based on the rate, sometime during signon.
    
    '8-31-04
    Dim dblInterval As Double
    lRetVal_LOCAL = GetPrivateProfileString("MAIN", "ScanInterval", ".001", strIniString, 9, "M201_grf.ini")
    M_201.scanInterval = CDbl(Val(strIniString))
    
    
    lRetVal_LOCAL = GetPrivateProfileString("SubChannels", "0", "1", strIniString, 8, "M201_grf.ini")
    M_201.chan(0) = Val(strIniString)
    lRetVal_LOCAL = GetPrivateProfileString("SubChannels", "1", "0", strIniString, 8, "M201_grf.ini")
    M_201.chan(1) = Val(strIniString)
    lRetVal_LOCAL = GetPrivateProfileString("SubChannels", "2", "0", strIniString, 8, "M201_grf.ini")
    M_201.chan(2) = Val(strIniString)
    lRetVal_LOCAL = GetPrivateProfileString("SubChannels", "3", "0", strIniString, 8, "M201_grf.ini")
    M_201.chan(3) = Val(strIniString)
    lRetVal_LOCAL = GetPrivateProfileString("SubChannels", "4", "0", strIniString, 8, "M201_grf.ini")
    M_201.chan(4) = Val(strIniString)
    lRetVal_LOCAL = GetPrivateProfileString("SubChannels", "5", "0", strIniString, 8, "M201_grf.ini")
    M_201.chan(5) = Val(strIniString)
    
    M_201.numChannels = 0
    Dim bIndex As Byte
    Dim bLowVal As Byte
    Dim bHiVal As Byte
    For bIndex = 0 To 5
        If M_201.chan(bIndex) <> 16 Then
            If ((M_201.chan(bIndex) And &HF0) \ 16) > (M_201.chan(bIndex) And &HF) Then
                M_201.chan(bIndex) = M_201.chan(bIndex) + ((M_201.chan(bIndex) And &HF0) \ 16)
            End If
        End If
    Next bIndex
    For bIndex = 0 To 5
        If M_201.chan(bIndex) <> 16 Then
            bLowVal = (M_201.chan(bIndex) And &HF0) \ 16
            bHiVal = (M_201.chan(bIndex) And &HF)
            M_201.numChannels = M_201.numChannels + (bHiVal - bLowVal) + 1
        End If
    Next bIndex
    
    
    Dim iChanVal, subChanTemp, mainChanTemp As Integer
    lRetVal_LOCAL = GetPrivateProfileString("MAIN", "singleChanScanMainChan", "0", strIniString, 2, "M201_grf.ini")
    mainChanTemp = Val(strIniString)
    If mainChanTemp > 5 Then mainChanTemp = 5
    lRetVal_LOCAL = GetPrivateProfileString("MAIN", "singleChanScanSubChan", "0", strIniString, 3, "M201_grf.ini")
    subChanTemp = Val(strIniString)
    If subChanTemp > 15 Then subChanTemp = 15
    M_201.channel = mainChanTemp
    M_201.subChan = subChanTemp
    M_201.singleChan = (mainChanTemp * 16) + subChanTemp
    iSingleChan_SAVE = M_201.singleChan
    
    
    'wordCnt    number of words in conversion (2 or 3)
    lRetVal_LOCAL = GetPrivateProfileString("MAIN", "wordCnt", "3", strIniString, 2, "M201_grf.ini")
    M_201.wordCnt = Val(strIniString)
    If M_201.wordCnt > 3 Then M_201.wordCnt = 3
    
    'biPolar    0 = unipolar  1 = bipolar
    lRetVal_LOCAL = GetPrivateProfileString("MAIN", "biPolar", "1", strIniString, 2, "M201_grf.ini")
    M_201.biPolar = Val(strIniString)
    If M_201.biPolar > 1 Then M_201.biPolar = 1
    
    'filter    0 = 4 Hz  1 = 40 Hz  2 = 400 Hz
    lRetVal_LOCAL = GetPrivateProfileString("MAIN", "filter", "2", strIniString, 2, "M201_grf.ini")
    M_201.filter = Val(strIniString)
    If M_201.filter > 2 Then M_201.filter = 2
    
    'gain    factor (powers of 2)  for example, 1, 2, 4, 8. 16. 32, 64, 128
    lRetVal_LOCAL = GetPrivateProfileString("MAIN", "gain", "1", strIniString, 2, "M201_grf.ini")
    M_201.gain = Val(strIniString)
    If (M_201.gain <> 1) And (M_201.gain <> 2) And (M_201.gain <> 4) And (M_201.gain <> 8) _
         And (M_201.gain <> 16) And (M_201.gain <> 32) And (M_201.gain <> 64) And (M_201.gain <> 128) Then
        M_201.gain = 1
    End If
    If M_201.gain > 128 Then M_201.gain = 128
    dblGain = CDbl(M_201.gain)
    frmGraph.ComboGain.Text = dblGain
    
    
    
    '## G R A P H I C S  ###########
    lRetVal_LOCAL = GetPrivateProfileString("Graphics", "autoscale", "1", strIniString, 2, "M201_grf.ini")
    bAutoScale = Val(strIniString)
    '3-30-04b If bAutoScale > 1 Then bAutoScale = 1
    If bAutoScale > 1 Then bAutoScale = 1
    If bAutoScale = 1 Then
        frmGraphTextVolts.BtnAutoCenter.Caption = "Auto Scale  (on)"
    Else
        bAutoScale = 0
        frmGraphTextVolts.BtnAutoCenter.Caption = "Auto Scale  (off)"
    End If
    
    lRetVal_LOCAL = GetPrivateProfileString("Graphics", "SecPerScrn", "60", strIniString, 7, "M201_grf.ini")
    dblXRange = Val(strIniString)
    dblXIndex = dblXRange
    
    frmGraph.SecPerScrn.Text = dblXRange
    bConfigChanges(CONFIG_GRAPH_SEC_PER_SCRN) = 0
    
    lRetVal_LOCAL = GetPrivateProfileString("Graphics", "MaxRange", "5.0", strIniString, 7, "M201_grf.ini")
    dblMaxFullScale = Val(strIniString)
    lRetVal_LOCAL = GetPrivateProfileString("Graphics", "MinRange", "-5.0", strIniString, 7, "M201_grf.ini")
    dblMinFullScale = Val(strIniString)
    
    If bAutoScale = 0 Then
        frmGraph.txtPosFullScale.Text = Format$(dblMaxFullScale, "##.00000")
        frmGraph.txtNegFullScale.Text = Format$(dblMinFullScale, "##.00000")
        'these were changed by us not user
        bConfigChanges(CONFIG_GRAPH_SCALE_MAX) = 0
        bConfigChanges(CONFIG_GRAPH_SCALE_MIN) = 0
        
    End If
    
    lRetVal_LOCAL = GetPrivateProfileString("MAIN", "LogScans", "1", strIniString, 2, "M201_grf.ini")
    bLogScanVal = Val(strIniString)
    If bLogScanVal > 1 Then bLogScanVal = 1
    '################################
'2-25-14
'MsgBox "4"
'On Error GoTo fixErr
'fixErr:
' Error = 0
'GoTo EXIT_ERR
    
    'was previously done in the loading of the offset voltage form
    If ReadIniFileSpecs_CHoffsets = False Then
'2-25-14
'MsgBox "4b"
        'Need to cover this in case the call completes with error (for example the file doesn't exist)
        '9-24-13 frmGraphTextVolts.txtUsingOffsetVoltage.Text = "NOT using offset voltage"
        bUseOffsetVoltages = 0
    Else
'2-25-14
'MsgBox "4c"
'        frmGraphTextVolts.txtUsingOffsetVoltage.Text = "USING offset voltage"
'        bUseOffsetVoltages = True
    End If
'2-25-14
'MsgBox "5"
    
    GoTo EXIT1

EXIT_ERR:

    MsgBox vbCrLf & "Failed to read  M201_grf.ini" & vbCrLf & vbCrLf & "Locate file and place in  Windows  directory." & vbCrLf & vbCrLf & "Or inspect for incorrect data format" & vbCrLf & vbCrLf

EXIT1:
    On Error GoTo 0
End Sub

